--------------------------------------------------------------------------------
-- Company: Digilent Inc.
-- Engineer:Dion Moses
--
-- Create Date:   11:31:13 09/03/2009 
-- Tool versions:  ISE 11
-- Description:  VHDL test bench design to coincide with problem 3 of
-- P4.doc of Digilent's Real Digital 
-- 
-- VHDL Test Bench Created by ISE for module: P4
-- 
-- Dependencies:
-- 
-- Revision: (DionM) : created
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;
LIBRARY UNISIM;
USE UNISIM.Vcomponents.ALL;
ENTITY P4problem3_sch_tb IS
END P4problem3_sch_tb;
ARCHITECTURE behavioral OF P4problem3_sch_tb IS 

   COMPONENT P4problem3
   PORT( A	:	IN	STD_LOGIC; 
          B	:	IN	STD_LOGIC; 
          C	:	IN	STD_LOGIC; 
          D	:	IN	STD_LOGIC; 
          E	:	IN	STD_LOGIC; 
          OUTPUT	:	OUT	STD_LOGIC);
   END COMPONENT;

   SIGNAL A	:	STD_LOGIC:='0';
   SIGNAL B	:	STD_LOGIC:='0';
   SIGNAL C	:	STD_LOGIC:='0';
   SIGNAL D	:	STD_LOGIC:='0';
   SIGNAL E	:	STD_LOGIC:='0';
   SIGNAL OUTPUT	:	STD_LOGIC;

	constant period : time := 10 ns;
BEGIN

   UUT: P4problem3 PORT MAP(
		A => A, 
		B => B, 
		C => C, 
		D => D, 
		E => E, 
		OUTPUT => OUTPUT
   );

stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '0';
		D<= '0';
		E<= '0';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '0';
		D<= '0';
		E<= '1';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '0';
		D<= '1';
		E<= '0';
		
		wait for period;	
		A<= '0';
      B<= '0';
		C<= '0';
		D<= '1';
		E<= '1';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '1';
		D<= '0';
		E<= '0';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '1';
		D<= '0';
		E<= '1';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '1';
		D<= '1';
		E<='0';
		
      wait for period;	
		A<= '0';
      B<= '0';
		C<= '1';
		D<= '1';
		E<='1';
		
      wait for period;	
		A<= '0';
      B<= '1';
		C<= '0';
		D<= '0';
		E<='0';
		
      wait for period;	
		A<= '0';
      B<= '1';
		C<= '0';
		D<= '0';
		E<='1';

      wait for period;	
		A<= '0';
      B<= '1';
		C<= '0';
		D<= '1';
		E<='0';
		
      wait for period;	
		A<= '0';
      B<= '1';
		C<= '0';
		D<= '1';
		E<='1';

      wait for period;	
		A<= '0';
      B<= '1';
		C<= '1';
		D<= '0';
		E<='0';
		
      wait for period;	
		A<= '0';
      B<= '1';
		C<= '1';
		D<= '0';
		E<='1';

      wait for period;	
		A<= '0';
      B<= '1';
		C<= '1';
		D<= '1';
		E<='0';
		
      wait for period;	
		A<= '0';
      B<= '1';
		C<= '1';
		D<= '1';
		E<='1';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '0';
		D<= '0';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '0';
		D<= '0';
		E<='1';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '0';
		D<= '1';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '0';
		D<= '1';
		E<='1';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '1';
		D<= '0';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '1';
		D<= '0';
		E<='1';

	   wait for period;	
		A<= '1';
      B<= '0';
		C<= '1';
		D<= '1';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '0';
		D<= '0';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '0';
		D<= '0';
		E<='1';

	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '0';
		D<= '1';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '0';
		D<= '1';
		E<='1';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '1';
		D<= '0';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '1';
		D<= '0';
		E<='1';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '1';
		D<= '1';
		E<='0';
		
	   wait for period;	
		A<= '1';
      B<= '1';
		C<= '1';
		D<= '1';
		E<='1';
      -- insert stimulus here 

      wait;
   end process;

END;
